import sys, path
#import import_ipynb
import plots.avl_tree as avl_tree
from matplotlib import pyplot as plt
from shapely.geometry import Point, Polygon, LineString
from shapely.geometry.base import BaseGeometry, geos_geom_from_py
from shapely import affinity
import numpy
import numpy as np
import math
import mpld3
import mplcursors
from fractions import Fraction
import random
from copy import deepcopy

a = 0.407


class Polygon2(object):

    def __init__(self, shell=None, holes=None):
        # super().__init__(shell=None, holes=None)
        self.shell = shell
        self.x_values = [vertex[0] for vertex in shell]
        self.y_values = [vertex[1] for vertex in shell]
        self.min_x, self.max_x = self.min_x_max_x(shell)
        self.min_y, self.max_y = self.min_y_max_y(shell)
        self.height = self.height(shell)
        self.width = self.width(shell)
        self.spine = self.spine(self.shell)
        self.left, self.right = self.splitter()
        self.slope = self.slope(self.spine)

    def min_x_max_x(self, shell):
        x_values = [point[0] for point in shell]
        return (min(x_values), max(x_values))

    def min_y_max_y(self, shell):
        y_values = [point[1] for point in shell]
        return (min(y_values), max(y_values))

    def height(self, coord):
        height = self.max_y - self.min_y
        return height

    def width(self, coord):
        width = self.max_x - self.min_x
        return width

    def translation(self, x, y):
        self.shell = [(point[0] + x, point[1] + y) for point in self.shell]
        self.spine = ((self.spine[0][0] + x, self.spine[0][1] + y), (self.spine[1][0] + x, self.spine[1][1] + y))
        self.left = [(point[0] + x, point[1] + y) for point in self.left]
        self.right = [(point[0] + x, point[1] + y) for point in self.right]
        self.min_x = self.min_x + x
        self.max_x = self.max_x + x
        self.min_y = self.min_y + y
        self.max_y = self.max_y + y
        self.x_values = [vertex + x for vertex in self.x_values]
        self.y_values = [vertex + y for vertex in self.y_values]
        return self.shell

    def spine(self, shell):
        y_sorted_p_p = sorted(shell, key=lambda k: k[
            1])  # Parser schreibt oder davon ausgeht das konvexe Polygone übergeben werden
        if y_sorted_p_p[0][1] == y_sorted_p_p[1][1]:
            if y_sorted_p_p[0][0] < y_sorted_p_p[1][0]:
                spine_bottom = y_sorted_p_p[0]
            else:
                spine_bottom = y_sorted_p_p[1]
        else:
            spine_bottom = y_sorted_p_p[0]
        if y_sorted_p_p[-2][1] == y_sorted_p_p[-1][1]:
            if y_sorted_p_p[-2][0] < y_sorted_p_p[-1][0]:
                spine_top = y_sorted_p_p[-1]
            else:
                spine_top = y_sorted_p_p[-2]
        else:
            spine_top = y_sorted_p_p[-1]
        return (spine_bottom, spine_top)

    def slope(self, spine):
        if spine[0][0] == spine[1][0]:  # Sonderfall für eine senkrechte
            slope = math.inf
        else:
            slope = (spine[1][1] - spine[0][1]) / (spine[1][0] - spine[0][
                0])  # m = y2-y1/x2-x1 Formel für die Geradensteigung mithilfe aus zwei verschiedenen Punkten der Geraden
        return slope

    def plot_polygon(self, title=None):
        fig, ax = plt.subplots(facecolor='w', edgecolor='k')
        x = self.x_values
        y = self.y_values
        for x_text, y_text in self.shell:
            ax.text(x_text, y_text, '({}, {})'.format(int(x_text * 10) / 10, int(y_text * 10) / 10))
        ax.plot(x, y)
        ax.scatter(x, y, s=60)
        if title == None:
            title = 'A single plot'
        ax.set_title(title)
        x1 = [x[0] for x in self.spine]
        y1 = [x[1] for x in self.spine]
        ax.plot(x1, y1)
        plt.close()
        #mplcursors.cursor()
        return mpld3.fig_to_html(fig)

    def splitter(self):
        left = []
        right = []
        spine_bottom = self.spine[0]
        spine_top = self.spine[1]
        help_array = self.shell.copy()
        spine_bottom_found = False
        spine_top_found = False
        spine_bottom_not_horizontal = False
        while spine_bottom_found == False:  # Phase 1 der Funktion sie sucht den bottom spine, dabei werden die Ecken die nicht der Spine Bottom sind ans Ende der Liste geschoben
            if help_array[0] == spine_bottom:
                if spine_bottom[1] != help_array[-1][
                    1]:  # checkt ob Spine bottom ein horizontalen Nachbar hat falls ja wird ein Flag gesetzt damit Spine bottomt später nicht in die Rechte mitgenommen wird
                    spine_bottom_not_horizontal = True
                spine_bottom_found = True
                left.append(help_array.pop(0))
            else:
                help_array.append(help_array.pop(0))
        while spine_top_found == False:  # iterieren die Liste erneut durch bis wir spine top finden, falls spine top gefunden wurde wird auch geschaut ob spine top ein horizontalen linken
            if help_array[0] == spine_top:  # Nachbar hat falls ja wird spine top nicht in die Linke Liste miteingefügt
                spine_top_found = True
                if spine_top[1] != left[-1][1]:
                    left.append(spine_top)
            else:
                left.append(help_array.pop(0))
        right = help_array.copy()
        if spine_bottom_not_horizontal:
            right.append(spine_bottom)
        return (left, right)


class HighClass(object):
    def __init__(self, i, alpha, h_max, w_max):
        self.i = i
        self.alpha = alpha
        self.h_max = h_max
        self.w_max = w_max
        self.min_border = alpha ** (i + 1) * h_max
        self.max_border = alpha ** (i) * h_max
        self.polygons = []
        self.spine_ordered_polygons = []

    def spine_order_polygons(self):
        spine_ordered_polygons = sorted(self.polygons, key=lambda polygon: polygon.slope)
        self.spine_ordered_polygons = spine_ordered_polygons
        return spine_ordered_polygons


def height_classes(polygon_list):
    ordered_polygons = sorted(polygon_list, key=lambda polygon: polygon.height, reverse=True)
    h_max = ordered_polygons[0].height
    # max([polygon.height for polygon in polygon_list])
    w_max = max([polygon.width for polygon in polygon_list])
    alpha = 0.407
    i = 0
    # h_i = height_max
    height_classes = []
    response = []
    polygon_count = len(ordered_polygons)
    while polygon_count > 0:
        hc = HighClass(i, alpha, h_max, w_max)
        # polygon_count= len(ordered_polygons)
        while polygon_count > 0 and hc.min_border < ordered_polygons[0].height and ordered_polygons[
            0].height <= hc.max_border:
            # print (alpha**(i+1)*h_max, ordered_polygons[0].height,alpha**(i)*h_max) # print
            hc.polygons.append(ordered_polygons.pop(0))
            polygon_count -= 1
        hc.spine_order_polygons()
        if len(hc.polygons) > 0:
            height_classes.append(hc)  # will man höhen Klassen ohne Polygone drinne ?
            # response.append([polygon.height for polygon in hc.polygons]) # print
        i += 1
    # print(Hresponse)
    # print([y.polygons for y in height_classes])
    return height_classes


def create_multiple_convex_polygons(number, max_ngon):
    polygon_list = []
    for count in range(0, number):
        polygon_list.append(create_convex_polygon(max_ngon))
    return polygon_list


def create_convex_polygon(
        max_ngon):  # die erste Koordinate der konvexen Polygone wird dupliziert zum schließen des Polygons
    convex = False
    ngon = numpy.random.randint(3, max_ngon + 1)
    # ries=0
    max_rand = 1000

    # tries=tries+1
    polygon_points = []
    while len(polygon_points) < ngon:

        x = numpy.random.randint(1, max_rand)
        y = numpy.random.randint(1, max_rand)
        #             x = numpy.random.random()
        #             y = numpy.random.random()
        while (x, y) in polygon_points:
            #             x = numpy.random.random()
            #             y = numpy.random.random()
            x = numpy.random.randint(1, max_rand)
            y = numpy.random.randint(1, max_rand)
        polygon_points.append((x, y))

    polygon = Polygon(polygon_points)
    polygon_parent_class = polygon.convex_hull
    polygon2 = Polygon2(list(polygon_parent_class.exterior.coords))
    # randomint = numpy.random.randint(minvert,maxvert)
    # response= numpy.random.rand(randomint,2)
    return polygon2


def plot_polygons(polygon_list):
    counter = 0
    polygon_number = len(polygon_list)
    fig, ax = plt.subplots(polygon_number, figsize=(18, 16), dpi=80, facecolor='w', edgecolor='k')
    plt.tight_layout(pad=10, w_pad=10, h_pad=3)

    for polygon in polygon_list:
        x = polygon.x_values
        y = polygon.y_values
        for x_text, y_text in polygon.shell:
            ax[counter].text(x_text, y_text, '({}, {})'.format(int(x_text * 10) / 10, int(y_text * 10) / 10), )
        ax[counter].plot(x, y)
        ax[counter].scatter(x, y, s=60)
        ax[counter].set_title('A single plot')
        x1 = [x[0] for x in polygon.spine]
        y1 = [x[1] for x in polygon.spine]

        ax[counter].plot(x1, y1)
        mplcursors.cursor()
        counter += 1


def pack_polygons(polygons):
    list_hc = height_classes(polygons)
    list_containers = building_containers(list_hc)
    list_mini_containers = pack_mini_containers(list_containers)
    end_container = End_Container(list_mini_containers, True)
    return end_container


class Container(object):
    def __init__(self, hc):
        self.hc = hc
        self.hc_copy = deepcopy(hc)
        self.y_boundary = hc.max_border
        self.x_boundary = 0
        self.sigma = []
        self.Tree = avl_tree.AVLTree()
        self.root = None
        self.box_boundarys_x_values = []
        self.plots=[]

    def plot_container(self, sigma, r_l_distances=None, l_r_distances=None, min_distance=None):
        fig, ax = plt.subplots(facecolor='w', edgecolor='k', figsize=(10, 8), dpi=90)
        # x,y= self.exterior.xy

        for polygon in sigma:
            x = []
            y = []
            for x_text, y_text in polygon.shell:
                x.append(x_text)
                y.append(y_text)
                # ax.text(x_text, y_text, '({}, {})'.format(int(x_text*10)/10, int(y_text*10)/10))
            # print(x,y)
            ax.plot(x, y)
            ax.scatter(x, y, s=60)
            x1 = [x[0] for x in polygon.spine]
            y1 = [x[1] for x in polygon.spine]
            ax.plot(x1, y1, linewidth=2, color='black')
        if self.box_boundarys_x_values != []:
            for boundary in self.box_boundarys_x_values:
                ax.plot([self.box_boundarys_x_values, self.box_boundarys_x_values], [0, self.y_boundary],
                        linestyle='--')
            ax.set_title('hc_{} Container -> Mini Containers'.format(self.hc.i))
        else:
            ax.set_title('hc_{} Container'.format(self.hc.i))
        if r_l_distances != None:
            for tuple in r_l_distances:
                x = tuple[0][0]
                corresponding_point_x = x - tuple[1]
                y = tuple[0][1]
                text_point_x, text_point_y = (x - tuple[1] / 2, y)
                distance = int(tuple[1])
                ax.text(text_point_x, text_point_y, '{}'.format(distance))
                if distance == int(min_distance):
                    ax.plot([tuple[0][0], corresponding_point_x], [y, y], linestyle='--', marker='<', color='green')
                else:
                    ax.plot([tuple[0][0], corresponding_point_x], [y, y], linestyle='--', marker='<', color='red')
        if l_r_distances != None:
            for tuple in l_r_distances:
                x = tuple[0][0]
                corresponding_point_x = x + tuple[1]
                y = tuple[0][1]
                text_point_x, text_point_y = (x + tuple[1] / 2, y)
                distance = int(tuple[1])
                ax.text(text_point_x, text_point_y, '{}'.format(distance))
                if distance == int(min_distance):
                    ax.plot([tuple[0][0], corresponding_point_x], [y, y], linestyle='--', marker='>', color='green')
                else:
                    ax.plot([tuple[0][0], corresponding_point_x], [y, y], linestyle='--', marker='>', color='blue')
        mplcursors.cursor()
        ax.plot([0, self.x_boundary, self.x_boundary, 0, 0], [0, 0, self.y_boundary, self.y_boundary, 0])
        return mpld3.fig_to_html(fig)

    def slope3(self, spine, point1):
        # y = m*x+n
        # (y-n)/m=x
        # n = y-m*x
        if spine[0][0] == spine[1][0]:  # Sonderfall für eine senkrechte
            distance = math.sqrt((spine[0][0] - point1[
                0]) ** 2)  # da der spine eine senkrechte ist -> der eintreffpunkt hat den gleichen y wert wie der punkt, in der Abstand formel fällt dieser wert weg
        elif spine[0][1] == point1[1]:
            distance = math.sqrt((spine[0][0] - point1[0]) ** 2 + (spine[0][1] - point1[1]) ** 2)
        else:
            slope = (spine[1][1] - spine[0][1]) / (spine[1][0] - spine[0][
                0])  # m = y2-y1/x2-x1 Formel für die Geradensteigung mithilfe aus zwei verschiedenen Punkten der Geraden
            # print("steigung", slope)
            # print(point1[1])
            n = spine[0][1] - (slope * spine[0][0])
            # print("y-achsenabnschnitt",n)
            point0_x = (point1[1] - n) / slope  # x=(y-n)/m
            # print("x-wert vom punkt",point0_x)
            point0 = (point0_x, point1[1])
            distance = math.sqrt((point0[0] - point1[0]) ** 2 + (point0[1] - point1[1]) ** 2)
        return distance

    def find_successor(self, vertex, array):
        for counter, top_edge_point in enumerate(array):
            if top_edge_point[1] >= vertex[1]:
                return (array[counter - 1], top_edge_point)

    def packing_container(self, hc_polygons, plot=None):
        tree = self.Tree
        p = []
        l = []
        r = []
        b = []
        sigma_helper = []  # vi
        for polygon in hc_polygons:
            sigma_helper.append(polygon)
            if self.sigma == []:
                transform_x = -polygon.min_x
                transform_y = -polygon.min_y
                # polygon.plot_polygon("before translation")
                polygon.translation(transform_x, transform_y)

                # polygon.plot_polygon("after translation")
                polygon_vertices = len(polygon.right)
                for count in range(0, polygon_vertices - 1):
                    vertice = polygon.right[count]
                    vertice_neighbour = polygon.right[count + 1]
                    self.root = self.Tree.insert_node(self.root, vertice[1], vertice, vertice_neighbour)
                self.sigma.append(polygon)
                self.x_boundary += polygon.width
                t = deepcopy(self.sigma)  # vi
                # t.append(polygon) # vi
                self.plots.append(self.plot_container(t))  # vi
            else:
                print("self.x boundary", self.x_boundary)
                # if polygon.min_x < self.x_boundary:
                transform_x = (self.x_boundary + abs(polygon.min_x)) + 10
                print("x_boundary:", self.x_boundary, "polygon min x abs", abs(polygon.min_x))
                print("transform x:", transform_x)
                print("polygon min x", polygon.min_x)
                #                 else:
                #                     transform_x=0
                transform_y = -polygon.min_y
                polygon.translation(transform_x, transform_y)
                print(self.sigma)  # vi
                min_horizontal_distance = math.inf
                print("tree/n", tree.printHelper(self.root, "", True))
                helper_0 = []
                for vertex in polygon.left:
                    vertex_y = vertex[1]
                    successor_vertex = self.Tree.find_edges(self.root, vertex_y, self.root)
                    corresponding_edge_points = (successor_vertex.vertice, successor_vertex.vertice_neighbour)
                    print("corresponding edge points", corresponding_edge_points, "for vertex", vertex)
                    distance = self.slope3(corresponding_edge_points, vertex)
                    if distance <= min_horizontal_distance:
                        min_horizontal_distance = distance
                    helper_0.append((vertex, distance))
                print("min_horizontal distance right to left", min_horizontal_distance)
                print("helper_0", helper_0)
                key = polygon.spine[1][1]
                print("key to order tree array", key)
                tree_array = self.Tree.preOrder_array((self.root), [], key)
                print("tree_array in order ", tree_array)
                helper_1 = []
                for vertex in tree_array:
                    print("vertex", vertex)
                    print("polygon left vertices", polygon.left)
                    successor = self.find_successor(vertex, polygon.left)
                    print(successor)
                    distance = self.slope3(successor, vertex)
                    print("distance", distance)
                    if distance <= min_horizontal_distance:
                        min_horizontal_distance = distance
                    self.root = self.Tree.delete_node(self.root, vertex[1])  # deleting vertices from B
                    helper_1.append((vertex, distance))  # -------
                #                 for count in range(0,polygon_vertices-1):
                #                     vertice = polygon.translated_right[count]
                #                     vertice_neighbour = polygon.translated_right[count+1]
                #                     self.root = self.Tree.insert_node(self.root,vertice[1],vertice,vertice_neighbour)
                print("min_horizontal distance left to right ", min_horizontal_distance)
                self.plots.append(self.plot_container(sigma_helper, helper_0, helper_1, min_horizontal_distance))  # ---------------------
                polygon.translation(-(min_horizontal_distance), 0)
                print(polygon.right)
                for counter, vertex in enumerate(polygon.right[0:-1]):
                    self.root = self.Tree.insert_node(self.root, vertex[1], vertex, (polygon.right[counter + 1]))
                x_boundary = max([vertex[0] for vertex in polygon.right] + [self.x_boundary])
                self.x_boundary = x_boundary
                self.sigma.append(polygon)

        if plot == True:
            self.plots.append(self.plot_container(self.sigma))
        self.plots.append(self.plot_container(self.sigma))
        return self.sigma


def building_containers(height_classes, plot=None):
    containers = []
    for height_class in height_classes:
        container = Container(height_class)
        if plot == True:
            container.packing_container(container.hc.spine_ordered_polygons, plot=True)
        else:
            container.packing_container(container.hc.spine_ordered_polygons)
        containers.append(container)
    return containers


class Mini_Container(object):
    def __init__(self, max_width, max_height):
        self.current_right_boundary = 0
        self.max_width = max_width
        self.height = max_height
        self.c = 2.214
        self.polygons = []
        self.y_offset = 0

    def plot_container(self, title=None):
        fig, ax = plt.subplots(facecolor='w', edgecolor='k', figsize=(20, 12), dpi=90)
        # x,y= self.exterior.xy

        for polygon in self.polygons:
            x = []
            y = []
            for x_text, y_text in polygon.shell:
                x.append(x_text)
                y.append(y_text)
                ax.text(x_text, y_text - (y_text * 0.1),
                        '({}, {})'.format(int(x_text * 10) / 10, int(y_text * 10) / 10), )
            # print(x,y)
            ax.plot(x, y)
            ax.scatter(x, y, s=60)
            if title == None:
                ax.set_title('Mini-Container')
            else:
                ax.set_title(title)
            x1 = [x[0] for x in polygon.spine]
            y1 = [x[1] for x in polygon.spine]
            ax.plot(x1, y1, linewidth=2, color='black')
        mplcursors.cursor()
        ax.plot([0, self.max_width, self.max_width, 0, 0],
                [0 + self.y_offset, 0 + self.y_offset, self.height + self.y_offset, self.height + self.y_offset,
                 0 + self.y_offset])
        return plt.show()


def pack_mini_containers(container_array, plot=None):
    mini_container_array = []
    for container in container_array:
        copy_container = container  # nochmal schauen ob der Schritt nötig ist bzw. ob nur ein Pointer kopiert wird statt eine deepcopy
        box_width = 2.214 * copy_container.hc.w_max
        box_width_helper = 0

        box_counter = 1
        # print("container boundarys",copy_container.x_boundary)
        while box_width_helper < copy_container.x_boundary:
            container.box_boundarys_x_values.append(box_width_helper)
            box_width_helper += box_width
        if plot == True:
            copy_container.plot_container(copy_container.sigma)
        max_width_mini_container = box_width + copy_container.hc.w_max
        while len(copy_container.sigma) > 0 and (box_width * box_counter) < (copy_container.x_boundary):
            # print("max_with,y_boundary",max_width_mini_container,(copy_container.y_boundary))
            mini_container = Mini_Container(max_width_mini_container, (copy_container.y_boundary))
            translation_flag = True
            while len(copy_container.sigma) > 0 and (copy_container.sigma[0].min_x) < (box_width * box_counter):
                if translation_flag:
                    translation = copy_container.sigma[0].min_x
                    translation_flag = False
                copy_container.sigma[0].translation(-translation, 0)
                mini_container.polygons.append(copy_container.sigma.pop(0))
                # mini_container.plot_container()
            mini_container.current_right_boundary = mini_container.polygons[-1].max_x
            mini_container_array.append(mini_container)
            if plot == True:
                title = "Mini-Container {} (hc_{})".format(box_counter, container.hc.i)
                mini_container.plot_container(title)
            box_counter += 1
        if len(copy_container.sigma) > 0:
            mini_container = Mini_Container(max_width_mini_container, copy_container.y_boundary)
            translation_flag = True
            while len(copy_container.sigma) > 0 and copy_container.sigma[0].min_x < box_width * box_counter:
                if translation_flag:
                    translation = copy_container.sigma[0].min_x
                    translation_flag = False
                copy_container.sigma[0].translation(-translation, 0)
                mini_container.polygons.append(copy_container.sigma.pop(0))
                # mini_container.plot_container()
            mini_container.current_right_boundary = mini_container.polygons[-1].max_x
            mini_container_array.append(mini_container)
            if plot == True:
                title = "Mini-Container {} (hc_{})".format(box_counter, container.hc.i)
                mini_container.plot_container(title)
    return mini_container_array


class End_Container(object):
    def __init__(self, mini_container_array, angle=0):
        self.mini_containers = mini_container_array
        self.pack_mini_containers()
        self.container_area = self.container_area(self.mini_containers)
        self.angle = angle

    def pack_mini_containers(self):
        y_offset = self.mini_containers[0].height
        for mini_container in self.mini_containers[1:]:
            for polygon in mini_container.polygons:
                polygon.translation(0, y_offset)
            mini_container.y_offset = y_offset
            y_offset += mini_container.height
        return

    def container_area(self, mini_containers):
        container_area = 0
        for mini_container in mini_containers:
            container_area += mini_container.max_width * mini_container.height
        return container_area

    def plot_container(self, title=None):
        fig, ax = plt.subplots(facecolor='w', edgecolor='k', figsize=(20, 12), dpi=90)
        # x,y= self.exterior.xy
        y_offset = 0
        for mini_container in self.mini_containers:
            for polygon in mini_container.polygons:
                x = []
                y = []
                for x_text, y_text in polygon.shell:
                    x.append(x_text)
                    y.append(y_text)
                    ax.text(x_text, y_text - (y_text * 0.1),
                            '({}, {})'.format(int(x_text * 10) / 10, int((y_text) * 10) / 10), )
                # print(x,y)
                ax.plot(x, y)
                ax.scatter(x, y, s=60)
                if title == None:
                    ax.set_title('End Container')
                else:
                    ax.set_title(title)
                x1 = [x[0] for x in polygon.spine]
                y1 = [x[1] for x in polygon.spine]
                ax.plot(x1, y1, linewidth=2, color='black')
            ax.plot([0, mini_container.max_width, mini_container.max_width, 0, 0],
                    [0 + y_offset, 0 + y_offset, mini_container.height + y_offset, mini_container.height + y_offset,
                     0 + y_offset])
            y_offset += mini_container.height
        mplcursors.cursor()
        return plt.show()


    # polygons = create_multiple_convex_polygons(15,5)
# hc = height_classes(polygons)
#
# containers = building_containers(hc,True) #plot=True
# print(id(containers[0].hc.spine_ordered_polygons),id(containers[0].hc_copy.spine_ordered_polygons))
# print(containers[0].hc.spine_ordered_polygons[0].plot_polygon(),"/n",containers[0].hc_copy.spine_ordered_polygons[0].plot_polygon())
# mini_containers = pack_mini_containers(containers,True) #plot=True
# end_container = End_Container(mini_containers)
# end_container.plot_container()
#end_container.container_area













